theory Defs
  imports Main
begin

declare[[syntax_ambiguity_warning=false]]
declare[[names_short]]
class height =
fixes height :: "'a \<Rightarrow> nat"

datatype 'a tree234 =
  Leaf |
  Node2 "'a tree234" 'a "'a tree234"  |
  Node3 "'a tree234" 'a "'a tree234" 'a "'a tree234"  |
  Node4 "'a tree234" 'a "'a tree234" 'a "'a tree234" 'a "'a tree234"

instantiation tree234 :: (type)height
begin

fun height_tree234 :: "'a tree234 \<Rightarrow> nat" where
"height Leaf = 0" |
"height (Node2 l _ r) = Suc(max (height l) (height r))" |
"height (Node3 l _ m _ r) = Suc(max (height l) (max (height m) (height r)))" |
"height (Node4 l _ m1 _ m2 _ r) = Suc(max (height l) (max (height m1) (max (height m2) (height r))))"

instance ..

end


fun complete :: "'a tree234 \<Rightarrow> bool" where
"complete Leaf = True" |
"complete (Node2 l _ r) = (complete l & complete r & height l = height r)" |
"complete (Node3 l _ m _ r) =
  (complete l & complete m & complete r & height l = height m & height m = height r)" |
"complete (Node4 l _ m1 _ m2 _ r) =
  (complete l & complete m1 & complete m2 & complete r & height l = height m1 & height m1 = height m2 & height m2 = height r)"


fun ordered :: "'a::linorder tree234 \<Rightarrow> bool" where
"ordered Leaf \<longleftrightarrow> True" |
"ordered (Node2 t1 v t2) \<longleftrightarrow>
 ordered t1 \<and> ordered t2 \<and> (\<forall>x\<in>set_tree234 t1. (<) x v) \<and> (\<forall>x\<in>set_tree234 t2. (<) v x)" |
"ordered (Node3 t1 v1 t2 v2 t3) \<longleftrightarrow>
 ordered t1 \<and> ordered t2 \<and> ordered t3 \<and> v1 < v2
 \<and> (\<forall>x\<in>set_tree234 t1. (<) x v1) \<and> (\<forall>x\<in>set_tree234 t2. (<) v1 x)
 \<and> (\<forall>x\<in>set_tree234 t2. (<) x v2) \<and> (\<forall>x\<in>set_tree234 t3. (<) v2 x)" |
"ordered (Node4 t1 v1 t2 v2 t3 v3 t4) \<longleftrightarrow>
 ordered t1 \<and> ordered t2 \<and> ordered t3 \<and> ordered t4 \<and> v1 < v2 \<and> v2 < v3
 \<and> (\<forall>x\<in>set_tree234 t1. (<) x v1) \<and> (\<forall>x\<in>set_tree234 t2. (<) v1 x)
 \<and> (\<forall>x\<in>set_tree234 t2. (<) x v2) \<and> (\<forall>x\<in>set_tree234 t3. (<) v2 x)
 \<and> (\<forall>x\<in>set_tree234 t3. (<) x v3) \<and> (\<forall>x\<in>set_tree234 t4. (<) v3 x)"


end
